#
# Copyright © 2020 MSC.Software Corporation
#  
# Permission to use Scripts
#  
# Permission is granted to MSC.Software customers with valid licenses of the MSC Apex™ software 
# to use script files posted on this page (collectively “Scripts”) solely for customers’ own authorized 
# internal use in conjunction with licensed use of the MSC Apex software.  
# No other use is permitted.  No license to MSC Apex or other software is granted under this Permission.
#  
# SCRIPTS ARE PROVIDED ON AN "AS-IS" BASIS, WITH NO WARRANTIES OF ANY KIND.  USE OF THE SCRIPTS IS AT CUSTOMER'S SOLE RISK.
#  
# IN NO EVENT SHALL MSC.SOFTWARE CORPORATION, ITS AFFILIATES, SUBSIDIARIES, SUPPLIERS, AGENTS, REPRESENTATIVES OR EMPLOYEES BE LIABLE FOR ANY 
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, TORT, 
# STRICT LIABILITY, OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION USE OF THE SCRIPTS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
#  
# Customer shall indemnify, defend and hold MSC.Software Corporation, its affiliates, subsidiaries, suppliers, agents, 
# employees or representatives (collectively, “Indemnified Parties”) harmless from and against any third-party claims 
# brought against Indemnified Parties rising out of or in connection with Customer’s use of the Scripts.
#
# MSC Apex - User Defined Tools using Python Scripts
# Data Grid script to be called by Data Grid UI Example
# 
def prepare_data_grid(grid={}):

    import apex

    # Disable showing output dialog at the end
    apex.disableShowOutput()

    # Display nodes and elements counts
    model = apex.currentModel()

    parts = [] 
    grid['parts'] = parts
    for part in model.parts:   
        partNode = {}
        parts.append(partNode)    
        partNode['part_name'] = part.name
        partNode['nodes_count'] = getTotalNodesCountFromPart(part)
        partNode['elements_count'] = getTotalElementsCountFromPart(part)
    
    return grid


def getTotalNodesCountFromPart(part):
    nodes = 0
    for entity in part.surfaces:
        nodes += entity.nodes.len()
    return nodes


def getTotalElementsCountFromPart(part):
    elements = 0
    for entity in part.surfaces:
        elements += entity.elements.len()
    return elements
